package hu.uniobuda.nik.voicerecorderwidget;

import android.app.PendingIntent;
import android.app.PendingIntent.CanceledException;
import android.appwidget.AppWidgetManager;
import android.appwidget.AppWidgetProvider;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.sax.StartElementListener;
import android.util.Log;
import android.widget.RemoteViews;

public class VoiceRecorderWidgetProvider extends AppWidgetProvider {

	private Intent voiceRecorderIntent,
				   voiceRecorderIntentStop,
				   voiceRecorderIntentPlay;
	
	@Override
	public void onUpdate(Context context, AppWidgetManager appWidgetManager, int[] appWidgetIds) {
		
		Log.d("vcw", "onupdate()");
		
		// Elindítjuk a service-t
		voiceRecorderIntent = new Intent(context, VoiceRecorderService.class);
		voiceRecorderIntent.setAction(VoiceRecorderService.ACTION_RECORD);
		PendingIntent voiceRecorderPendingIntent = PendingIntent.getService(context, 1027, voiceRecorderIntent, PendingIntent.FLAG_UPDATE_CURRENT);
		
		// Leallitjuk a felvetelt, es vele a service-t is
		voiceRecorderIntentStop = new Intent(context, VoiceRecorderService.class);
		voiceRecorderIntentStop.setAction(VoiceRecorderService.ACTION_STOP);
		PendingIntent voiceRecorderPendingIntentStop = PendingIntent.getService(context, 1027, voiceRecorderIntentStop, PendingIntent.FLAG_UPDATE_CURRENT);
		
		// Lejatszuk a felvetelt
		voiceRecorderIntentPlay = new Intent(context, VoiceRecorderService.class);
		voiceRecorderIntentPlay.setAction(VoiceRecorderService.ACTION_PLAY);
		PendingIntent voiceRecorderPendingIntentPlay = PendingIntent.getService(context, 1027, voiceRecorderIntentPlay, PendingIntent.FLAG_UPDATE_CURRENT);
		
		// Gombok beállítása
		RemoteViews views = new RemoteViews(context.getPackageName(), R.layout.voice_recorder_widget_layout);
		views.setOnClickPendingIntent(R.id.recordButton, voiceRecorderPendingIntent);
		views.setOnClickPendingIntent(R.id.stopButton,   voiceRecorderPendingIntentStop);
		views.setOnClickPendingIntent(R.id.playButton, voiceRecorderPendingIntentPlay);
		
		// Widget frissítése
		ComponentName thisWidget = new ComponentName(context, VoiceRecorderWidgetProvider.class);
		appWidgetManager.updateAppWidget(thisWidget, views);
		
	}
	
	
	@Override
	public void onDeleted(Context context, int[] appWidgetIds) {
		voiceRecorderIntentStop = new Intent(context, VoiceRecorderService.class);		
		context.stopService(voiceRecorderIntentStop);
		
		super.onDeleted(context, appWidgetIds);
	}
	
}
